/**
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2004 satoshi akabane(akabane@logical-paradox.org)
 *
 */
package org.logical_paradox.shell;

import org.logical_paradox.shell.exception.CommandExecutionException;


/**
 * _Ci~bNR}h[_[
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.5 $
 */
public class DynamicCommandLoader {
	/** R}hi[ĂpbP[W */
	private String packageIdentifier = null;
	private ShellEnv env = null;

	/**
	 * RXgN^
	 * @param se VFϐ
	 */
	public DynamicCommandLoader(ShellEnv se) {
		env = se;
		if(env != null && env.getProperty("COMMAND_PACKAGE_NAME") != null) {
			packageIdentifier = env.getProperty("COMMAND_PACKAGE_NAME");
		}
	}
	/**
	 * wR}h[h
	 * @param name R}h
	 * @return [hCX^XꂽR}hNX
	 * @throws ClassNotFoundException w肳ꂽÕNXNXpXɑ݂Ȃ
	 * @throws InstantiationException [hɎs
	 * @throws IllegalAccessException CX^XɕKvȃZLeBt^ĂȂ
	 * @throws CommandExecutionException ꂽNXR}hłȂ
	 */
	Command load(String name) throws InstantiationException, IllegalAccessException, CommandExecutionException {
		Class commandClass = null;
		Command command = null;
		try {
			if(packageIdentifier != null) {
				name = packageIdentifier + "." + name;
			}
			commandClass = ClassLoader.getSystemClassLoader().loadClass(name);
			command = (Command)commandClass.newInstance();
			if(command instanceof Command == false) {
				throw new CommandExecutionException();
			}
		} catch (ClassNotFoundException e) {
			// w肳ꂽR}hȂꍇ
			throw new CommandExecutionException();
		}
		return command;
	}
}
