/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DfsConfig.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.dfs;

import java.util.Enumeration;
import java.util.ResourceBundle;

import org.logical_paradox.common.util.StringUtils;
import org.logical_paradox.vsan.ConfigException;

/**
 * hCt@CVXẽRtBO[V
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class DfsConfig {
	/** ftHg̐ڑLZbV */
	public static final int DEFAULT_DOMAIN_SESSION_CONNECTIONS = 5;
	/** ftHg̃ZbV^CAEgb */
	public static final int DEFAULT_DOMAIN_SESSION_TIMEOUT = 36000;
	/** ftHg̃RlNVv[O */
	public static final int DEFAULT_CONNECTION_MAX = 25;
	/** ftHg̃hCXVmFԊu = 1 */
	public static final long DEFAULT_DOMAIN_SYNCHRO_INTERVAL = 1000 * 60 * 60;
	/** ftHg̃NCAgڑĎԊu = 1 */
	public static final long DEFAULT_CLIENT_MONITOR_INTERVAL = 1000 * 60 * 60;

	/** hC */
	private String domainPreconnectId;
	/** ڑhCRg[[ID */
	private String domainControllerId;
	/** ̃hCɑ΂őڑ */
	private int domainConnectionMax = DEFAULT_CONNECTION_MAX;
	/** 1̐ڑLZbV */
	private int domainSessionConnections = DEFAULT_DOMAIN_SESSION_CONNECTIONS;
	/** ZbV^CAEgb */
	private long domainSessionTimeout = DEFAULT_DOMAIN_SESSION_TIMEOUT;
	/** hCXV^C~O */
	private long domainSynchroInterval = DEFAULT_DOMAIN_SYNCHRO_INTERVAL;
	/** NCAgڑĎԊu */
	private long clientMonitorInterval = DEFAULT_CLIENT_MONITOR_INTERVAL;
	/** R[hݎ̌Œ蒷w */
	private boolean fixed = true;

	/**
	 * RXgN^
	 * @param p vpeBt@C̓e
	 * @throws ConfigException ݒlɖ肪ꍇɑoO
	 */
	public DfsConfig(ResourceBundle rc) throws ConfigException {
		parse(rc);
	}
	/**
	 * vpeBl荞ŉ͂
	 * vpeBlɖ肪ꍇAO𑗏o
	 * @param p vpeBl
	 * @throws ConfigException vpeBlɖ肪
	 */
	protected void parse(ResourceBundle rc) throws ConfigException {
		for(Enumeration e = rc.getKeys(); e.hasMoreElements();) {
			String key = (String)e.nextElement();
			String value = rc.getString(key);

			if("domain.controller.id".equals(key) == true) {
				domainControllerId = value;
			} else if("domain.preconnect.id".equals(key) == true) {
				domainPreconnectId = value;
			} else if("domain.connection.max".equals(key) == true) {
				domainConnectionMax = Integer.parseInt(value);
			} else if("domain.session.connections".equals(key) == true) {
				domainSessionConnections = Integer.parseInt(value);
			} else if("domain.session.timeout".equals(key) == true) {
				domainSessionTimeout = Long.parseLong(value);
			} else if("domain.synchrno.interval".equals(key) == true) {
				domainSynchroInterval = Long.parseLong(value);
			} else if("client.monitor.interval".equals(key) == true) {
				clientMonitorInterval = Long.parseLong(value);
			} else if("domain.record.type".equals(key) == true) {
				if("fixed".equals(value.toLowerCase()) == true) {
					fixed = true;
				} else if("variable".equals(value.toLowerCase()) == true) {
					fixed = false;
				} else {
					throw new ConfigException("'" + value + "' is invalid value of domain.record.type");
				}
			} else {
				throw new ConfigException(key);
			}
		}

		// K{ڂ̃`FbN
		// ̃m[hIDƁAڑhCRg[[Kv
		if(
			StringUtils.isEmpty(domainControllerId) == true ||
			StringUtils.isEmpty(domainPreconnectId) == true
		) {
			throw new ConfigException();
		}
	}

	/**
	 * R[h݂Œ蒷ōsǂԂD
	 * @return true:Œ蒷 / false:ϒ
	 */
	public boolean isFixed() {
		return fixed;
	}
	/**
	 * NCAgڑĎԊuԂD
	 * @return NCAgڑĎԊu(msec)
	 */
	public long getClientMonitorInterval() {
		return clientMonitorInterval;
	}
	/**
	 * hCXVmFԊuԂD
	 * @return hCXVmFԊu
	 */
	public long getDomainSynchroInterval() {
		return domainSynchroInterval;
	}

	/**
	 * ڑhCRg[[IDԂ
	 * @return ڑhCRg[[ID
	 */
	public String getDomainControllerId() {
		return domainControllerId;
	}

	/**
	 * NɐڑhCԂ
	 * @return hC
	 */
	public String getDomainPreconnectId() {
		return domainPreconnectId;
	}

	/**
	 * 1̐ڑLZbVԂ
	 * @return 1̐ڑLZbV
	 */
	public int getDomainSessionConnections() {
		return domainSessionConnections;
	}

	/**
	 * ZbV^CAEgbԂ
	 * @return ZbV^CAEgb
	 */
	public long getDomainSessionTimeout() {
		return domainSessionTimeout;
	}

	/**
	 * őڑԂ
	 * @return őڑ
	 */
	public int getDomainConnectionMax() {
		return domainConnectionMax;
	}

}
