/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: Domain.java,v 1.2 2005/09/28 16:14:44 rampil Exp $
 */
package org.logical_paradox.vsan.domain;

import java.io.Serializable;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.logical_paradox.vsan.node.DiskArrayNode;

/**
 * hC
 * hCɐڑؒf肵܂
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class Domain implements Serializable {
	/** hC */
	private final String name;
	/** hCɎQĂURĨXg */
	private final HashMap uris = new HashMap();
	/** ̈g\ȃhCǂ */
	private boolean autoExpandable = true;
	/** R[hTCY */
	private int recordSize = -1;

	/**
	 * RXgN^
	 * @param String dn hC
	 * @param nodes hCɎQĂm[h̃Xg
	 */
	public Domain(String dn, DiskArrayNode[] nodes) {
		name = dn;
		autoExpandable = true;

		// m[h̃Xgǉ
		for(int i = 0; i < nodes.length; i++) {
			add(nodes[i]);
		}
	}
	/**
	 * RXgN^
	 * @param String dn hC
	 * @param nodes hCɎQĂm[h̃Xg
	 * @param ae ̈g\ǂ(true:g\ / false:gs\)
	 */
	public Domain(String dn, DiskArrayNode[] nodes, boolean ae) {
		this(dn, nodes);
		autoExpandable = ae;
	}
	/**
	 * hCɃm[hi[Ă邩ǂԂD
	 * @return true:QĂm[h / false:QĂm[hȂ
	 */
	public boolean isEmpty() {
		return uris.size() == 0;
	}
	/**
	 * hCԂ
	 * @return hC
	 */
	public String getDomainName() {
		return name;
	}
	/**
	 * ̃hCɑ΂ăm[hǉ
	 * @param node m[h
	 */
	public void add(DiskArrayNode node) {
		if(recordSize < 0) {
			recordSize = node.getRecordSize();
		}
		uris.put(node.getHost(), node);
	}
	/**
	 * ̃hCwm[h𗣒E
	 * @param node EΏۃm[h
	 */
	public void remove(String node) {
		uris.remove(node);
	}
	/**
	 * R[hTCYԂD
	 * @return R[hTCY
	 */
	public int getRecordSize() {
		return recordSize;
	}
	/**
	 * ̃hCɎQĂm[hԂ
	 * ԋpꂽm[h̃Xg͍XVs\Ƃ
	 * @return m[h
	 */
	public Map getNodeList() {
		return Collections.unmodifiableMap(uris);
	}
	/**
	 * ̈g\ȃhCǂԂ
	 * @return true:g\ / false:gs\
	 */
	public boolean isAutoExpandable() {
		return autoExpandable;
	}
	/**
	 * hC̃nbVR[hԂD
	 * nbVR[hł΁AƂӖD
	 * @return nbVR[h
	 */
	public int hashCode() {
		int hc = 11 * uris.size();
		int radix = 3;

		for(Iterator it = uris.keySet().iterator(); it.hasNext();) {
			String uri = (String)it.next();
			hc += radix * uri.hashCode();
			radix *= radix /2;
		}

		return hc;
	}

}
