/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: LookupFactory.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.lookup;

/**
 * vsanp̃T[rXWbNt@Ng
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class LookupFactory {
	/** bNAbv^Cv - RMIɂ */
	public static final int TYPE_RMI = 1;
	/** bNAbv^Cv - hashmapɂ */

	public static final int TYPE_HASHMAP = 2;
	/** RMIɂڑs^CṽbNAbv */
	private static final Lookup rmiLookup = new RMILookup();
	/** HashMapWXgƂ^CṽbNAbv */
	private static final Lookup hashmapLookup = new HashMapLookup();

	/** ftHg̃bNAbv^Cv */
	private static int defaultLookupType = TYPE_RMI;

	/**
	 * ftHgbNAbvݒ肷B
	 * @param type bNAbv̎
	 */
	public static final void setDefaultLookupType(int type) {
		defaultLookupType = type;
	}
	/**
	 * T[rXWbN擾.
	 * @return T[rXWbN
	 */
	public static final Lookup getLookup() {
		return getLookup(defaultLookupType);
	}
	/**
	 * T[rXWbN擾.
	 * @param type ^Cv
	 * @return bNAbv
	 */
	public static final Lookup getLookup(int type) {
		switch(type) {
			// RMI
			case TYPE_RMI:
				return rmiLookup;
			// HashMap
			case TYPE_HASHMAP:
				return hashmapLookup;
			default:
				throw new IllegalArgumentException();
		}
	}
}
