/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DiskArrayNode.java,v 1.3 2005/09/28 16:14:59 rampil Exp $
 */
package org.logical_paradox.vsan.node;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

import org.logical_paradox.vsan.node.dbr.RecordSet;

/**
 * fBXNACm[h
 * ̃m[hɊւi[IuWFNg
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.3 $
 */
public class DiskArrayNode implements Serializable {
	/** zXgAhX */
	private String host;
	/** R[hZbg */
	private ArrayList recordSets = new ArrayList();

	/** JnR[hԍ(add邲ƂɍXV) */
	private long recordBegin = 0;
	/** IR[hԍ(add邱ǂɍXV) */
	private long recordEnd = 0;

	/**
	 * RXgN^
	 */
	public DiskArrayNode() {
	}
	/**
	 * RXgN^D
	 * @param nodeId_ m[hID
	 */
	public DiskArrayNode(String nodeId_) {
		host = nodeId_;
	}
	/**
	 * RXgN^D
	 * @param nodeId_ m[hID
	 * @param records R[hZbg
	 */
	public DiskArrayNode(String nodeId_, ArrayList records) {
		this(nodeId_);
		recordSets.addAll(records);
	}
	/**
	 * R[h̃TCYԂD
	 * @return R[h̃TCY(-1: R[h1Ȃ)
	 */
	public int getRecordSize() {
		return recordSets.size() == 0 ? -1 : ((RecordSet)recordSets.get(0)).getRecordSize();
	}
	/**
	 * m[h̃zXgAhXݒ肷D
	 * @param nodeId_ zXgAhX
	 */
	public void setHost(String host_) {
		host = host_;
	}
	/**
	 * m[h̃zXgAhXԂD
	 * @return zXgAhX
	 */
	public String getHost() {
		return host;
	}
	/**
	 * R[hZbgݒ肷D
	 * @param sets R[hZbg
	 */
	public void setRecordSets(ArrayList sets) {
		recordSets = sets;
	}
	/**
	 * R[hZbgǉD
	 * @param rs ǉ郌R[hZbg
	 */
	public void add(RecordSet rs) {
		recordSets.add(rs);

		if(rs.getRecordBegin() < recordBegin) {
			recordBegin = rs.getRecordBegin();
		}
		if(rs.getRecordEnd() > recordEnd) {
			recordEnd = rs.getRecordEnd();
		}
	}
	/**
	 * R[hZbg̃Ce[^ԂD
	 * @return Ce[^
	 */
	public Iterator recordSet() {
		return recordSets.iterator();	
	}
	/**
	 * ̃m[hw背R[hԍ܂ނǂԂD
	 * @param record R[hԍ
	 * @return true:܂ / false:܂܂Ȃ
	 */
	public boolean contains(long record) {
		for(Iterator it = recordSets.iterator(); it.hasNext();) {
			RecordSet rs = (RecordSet)it.next();
			if(rs.includes(record) == true) {
				return true;
			}
		}
		return false;
	}
	/**
	 * JnR[hԍԂD
	 * @return JnR[hԍ
	 */
	public long getRecordBegin() {
		return recordBegin;
	}
	/**
	 * IR[hԍԂD
	 * @return IR[hԍ
	 */
	public long getRecordEnd() {
		return recordEnd;
	}
	/**
	 * ̃R[hZbgJo[ĂTCYԂD
	 * @return Jo[hTCY
	 */
	public long getSize() {
		long size = 0;

		for(Iterator it = recordSets.iterator(); it.hasNext();) {
			RecordSet rs = (RecordSet)it.next();
			size += rs.getSize();
		}

		return size;
	}
	/**
	 * fBXNACm[hrD
	 * PɃm[ĥ݂ŔrD
	 * @param o rΏ
	 */
	public boolean equals(Object o) {
		if(o instanceof DiskArrayNode == false) {
			return false;
		}

		DiskArrayNode buddy = (DiskArrayNode)o;
		return getHost().equals(buddy.getHost());
	}
}
