/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: dac.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.tools.console.command;

import java.io.OutputStream;
import java.io.PrintWriter;

import org.logical_paradox.shell.Argument;
import org.logical_paradox.shell.Command;
import org.logical_paradox.shell.Option;
import org.logical_paradox.shell.ResultCode;
import org.logical_paradox.shell.ShellEnv;
import org.logical_paradox.shell.exception.CommandExecutionException;
import org.logical_paradox.shell.exception.TerminationException;
import org.logical_paradox.vsan.tools.console.DacConsoleConstant;

/**
 * <pre>
 * dac
 * 
 * ydlz
 * DAC݈̏ʒu\܂͕ύX܂B
 * 
 * yz
 * dac [zXgAhX]
 * 
 * yz
 * dac (݂DACݒ\܂)
 * dac localhost:9876 (DACݒlocalhost:9876ɕύX܂)
 * </pre>
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class dac implements Command {
	public static final String USAGE = "dac [<hostname>[:<port>]]";

	public String usage() {
		return USAGE;
	}

	public ResultCode execute(OutputStream o, ShellEnv env, Argument a) throws CommandExecutionException, TerminationException {
		if(a == null) {
			a = new Argument();
		}
		String[] args = a.getArguments();
		Option[] opts = (Option[])a.getOptions();

		if(args.length > 1 || opts.length > 0) {
			// ̐s
			throw new CommandExecutionException();
		}

		if(args.length == 0) {
			// zXgݒȂ̏ꍇ
			PrintWriter pw = new PrintWriter(o);
			String dachost = env.getProperty(DacConsoleConstant.ENV_DAC);
			if(dachost == null) {
				dachost = DacConsoleConstant.DACC_UNDEFINED_HOST;
			}
			pw.println(dachost);
			pw.flush();
			pw.close();
		} else {
			// zXgݒ肠̏ꍇ
			// ϐɑ΂DAC̐ݒ
			env.setProperty(DacConsoleConstant.ENV_DAC, args[0]);
		}
		return new ResultCode(ResultCode.STATUS_OK);
	}

}
